<?php
  /* @file
   * 
   */
   $id = $_GET['id'];
   $sid = $_GET['sid'];
   $web_address = $_SERVER['SERVER_NAME'];
?>
<html>
<head>
 
<title>SCORM 1.2 - RTE API</title>

<script language="javascript">

/**
 * The following eight functions are the interface between SCORM and LMS.
 * In this project, at the server side, there are eight corresponding functions
 * with the same names as these eight. all of the javascript functions use 
 * ajax request object to call the corresponding server-side functions and to send
 * data by "POST". one thing need to notice is this is for drupal site, and at server
 * side, the clean url need to be enabled.
 */
 
  var website_address = 'http://www.<?php print $web_address; ?>/lms/';
 
/************************************************************/
/********************** Cache Part **************************/

//right now, I only implemented the write-back cache.
//no read cache yet.
// ------------------------------------------
//   Status Flags
// ------------------------------------------
//var flagFinished = false;
//var flagInitialized = false;
var cache;
var interaction_count = 0;
/************************************************************/
 
// ------------------------------------------
//   SCORM RTE Functions - Initialization
// ------------------------------------------
function LMSInitialize(dummyString) { 
  
  cache = new Array();
  
  interaction_count = 0;
  
  return transferData('POST','LMSInitialize', ' ', true,false);

}
 
// ------------------------------------------
//   SCORM RTE Functions - Getting Values
// ------------------------------------------
function LMSGetValue(varname) {
  
  switch(varname)
  {
    case "cmi.interactions._count":
    {
      return interaction_count++;
    }
    
    default:
    {
      var parameters = 'variableName='+urlencode(varname);

      return transferData('POST', 'LMSGetValue', parameters, true,false);
    }
  }

}
 
// ------------------------------------------
//   SCORM RTE Functions - Setting Values
// The only job this function needs to do is 
// to write cache.
// ------------------------------------------
function LMSSetValue(varname,varvalue) {
  
  cache[varname] = varvalue;
  
  return "true";
  
}
 
// ------------------------------------------
//   SCORM RTE Functions - Commit
// ------------------------------------------
function LMSCommit(dummyString) {
  
  var parameters = _wrapup_cache();
  
  transferData('POST', 'LMSCommit', parameters, false, false);
  
  return "true";
 }

function _wrapup_cache()
{
  var paras = '';
  
  var d = new Date();
    
  paras += ('code=' + d.getTime());
  
  for ( var key in cache ){
  
    paras += ( "&data[" + key + "]=" + urlencode(cache[key]) );
  }
  
  return paras;
}
 
// ------------------------------------------
//   SCORM RTE Functions - Closing The Session
// ------------------------------------------
function LMSFinish(dummyString) {
    
  transferData('POST','LMSFinish', '', false,false);
  
  return "true";
}
 
// ------------------------------------------
//   SCORM RTE Functions - Error Handling
// ------------------------------------------
function LMSGetLastError() {
	return 0;
}

function LMSGetDiagnostic(errorCode) {
	return "diagnostic string";
}

function LMSGetErrorString(errorCode) {
	return "error string";
}

/**
 *   @sendingWay:   POST or GET.
 *   @functionName:  The name of the calling function.
 *   @parameters:  The parameters needs to be sent to the server side.
 *  @ifReturnValue:  If the calling function needs to get the return value from server-side.
 *  @synchronize:  If the calling function needs to wait until the value is returned.
 */
function transferData(sendingWay,functionName, parameters, ifReturnValue, synchronize)
{
  // create request object
  var req = createRequest();

  var url = website_address + functionName;
  //alert('url' + url);// test that your website name is correct
  
  if(sendingWay == 'GET') //GET
  {
    // set up request parameters - uses GET method
    req.open('GET', url, synchronize);
    
    // submit to the server for processing
    req.send(null);
  }
  else //POST
  {
    // set up request parameters
    req.open('POST', url, synchronize);
    
    // send header information along with the POST data
    var params = ("scoid=" + "<?php print $id; ?>&sid=" + "<?php print $sid; ?>&");
    params += parameters;
    
    req.setRequestHeader("Content-type","application/x-www-form-urlencoded");
    req.setRequestHeader("Content-length", params.length);
    req.setRequestHeader("Connection", "close");

    // submit to the server for processing
    req.send(params);
  }
  
  // process returned data - error condition
  if (req.status != 200) {
    alert('Problem with Request, req.status is ' + req.status);
    return "false";
  }
  else
  {
    if(ifReturnValue)
    {
      return req.responseText;
    }
    else
    {
      return "true";
    }
  }
}
 

function createRequest() {
 
  // this is the object that we're going to (try to) create
  var request;
 
  // does the browser have native support for 
  // the XMLHttpRequest object
  try {
    request = new XMLHttpRequest();
  }
 
  // it failed so it's likely to be Internet Explorer which 
  // uses a different way to do this
  catch (tryIE) {
 
    // try to see if it's a newer version of Internet Explorer
    try {
      request = new ActiveXObject("Msxml2.XMLHTTP");
    } 
 
    // that didn't work so ...
    catch (tryOlderIE) {
 
      // maybe it's an older version of Internet Explorer
      try {
        request = new ActiveXObject("Microsoft.XMLHTTP");
      }
 
      // even that didn't work (sigh)
      catch (failed) {
        alert("Error creating XMLHttpRequest");
      }
 
    }
  }
 
  return request;
}

/**
 * This code was grabbed from the "http://www.vsscorm.net/2009/06/14/the-lmssetvalue-function/"
 * http://www.vsscorm.net/2010/04/30/download-vs-scorm-1-2-rte-rev-2-1/#more-1254
 */
function urlencode( str ) {
  //
  // Ref: http://kevin.vanzonneveld.net/techblog/article/javascript_equivalent_for_phps_urlencode/
  //
  // %          note 1: info on what encoding functions to use from: http://xkr.us/articles/javascript/encode-compare/
  // *     example 1: urlencode('Kevin van Zonneveld!');
  // *     returns 1: 'Kevin+van+Zonneveld%21'
  // *     example 2: urlencode('http://kevin.vanzonneveld.net/');
  // *     returns 2: 'http%3A%2F%2Fkevin.vanzonneveld.net%2F'
  // *     example 3: urlencode('http://www.google.nl/search?q=php.js&ie=utf-8&oe=utf-8&aq=t&rls=com.ubuntu:en-US:unofficial&client=firefox-a');
  // *     returns 3: 'http%3A%2F%2Fwww.google.nl%2Fsearch%3Fq%3Dphp.js%26ie%3Dutf-8%26oe%3Dutf-8%26aq%3Dt%26rls%3Dcom.ubuntu%3Aen-US%3Aunofficial%26client%3Dfirefox-a'
 
    var histogram = {}, unicodeStr='', hexEscStr='';
    var ret = (str+'').toString();
 
    var replacer = function(search, replace, str) {
        var tmp_arr = [];
        tmp_arr = str.split(search);
        return tmp_arr.join(replace);
    };
 
    // The histogram is identical to the one in urldecode.
    histogram["'"]   = '%27';
    histogram['(']   = '%28';
    histogram[')']   = '%29';
    histogram['*']   = '%2A';
    histogram['~']   = '%7E';
    histogram['!']   = '%21';
    histogram['%20'] = '+';
    histogram['\u00DC'] = '%DC';
    histogram['\u00FC'] = '%FC';
    histogram['\u00C4'] = '%D4';
    histogram['\u00E4'] = '%E4';
    histogram['\u00D6'] = '%D6';
    histogram['\u00F6'] = '%F6';
    histogram['\u00DF'] = '%DF';
    histogram['\u20AC'] = '%80';
    histogram['\u0081'] = '%81';
    histogram['\u201A'] = '%82';
    histogram['\u0192'] = '%83';
    histogram['\u201E'] = '%84';
    histogram['\u2026'] = '%85';
    histogram['\u2020'] = '%86';
    histogram['\u2021'] = '%87';
    histogram['\u02C6'] = '%88';
    histogram['\u2030'] = '%89';
    histogram['\u0160'] = '%8A';
    histogram['\u2039'] = '%8B';
    histogram['\u0152'] = '%8C';
    histogram['\u008D'] = '%8D';
    histogram['\u017D'] = '%8E';
    histogram['\u008F'] = '%8F';
    histogram['\u0090'] = '%90';
    histogram['\u2018'] = '%91';
    histogram['\u2019'] = '%92';
    histogram['\u201C'] = '%93';
    histogram['\u201D'] = '%94';
    histogram['\u2022'] = '%95';
    histogram['\u2013'] = '%96';
    histogram['\u2014'] = '%97';
    histogram['\u02DC'] = '%98';
    histogram['\u2122'] = '%99';
    histogram['\u0161'] = '%9A';
    histogram['\u203A'] = '%9B';
    histogram['\u0153'] = '%9C';
    histogram['\u009D'] = '%9D';
    histogram['\u017E'] = '%9E';
    histogram['\u0178'] = '%9F';
 
    // Begin with encodeURIComponent, which most resembles PHP's encoding functions
    ret = encodeURIComponent(ret);
 
    for (unicodeStr in histogram) {
        hexEscStr = histogram[unicodeStr];
        ret = replacer(unicodeStr, hexEscStr, ret); // Custom replace. No regexing
    }
 
    // Uppercase for full PHP compatibility
    return ret.replace(/(\%([a-z0-9]{2}))/g, function(full, m1, m2) {
        return "%"+m2.toUpperCase();
    });
} 
 
</script>
 
</head>
<body>
 
<p>&nbsp;
 
</body>
</html>