<?php
  /*
   * @file
   * 
   */
  //object array
  $sco_main_report;
  
  //current sco object
  $sco_content;
  
  //array of all questions for all group members
  $sco_questions_list;
  
  //sco content list, array of array
  $sco_list;

  //group id
  $group_id;
  
  // array of 18 websafe colors
  // The last 9 of dark versions of the first 9
  $chart_colors = array('ff0000' , 
    'ffff00' , '0000ff' , '00ff00' , '9900ff' , 'ff9900' , 
    '00cccc' , 'ff00ff' , '663300' , '440000' , '999900' , 
    '000044' , '004400' , '330033' , '996600' , '003333' , 
    '990099' , '664433' );
	
	// Page Header
	echo "<p>Below you will find aggregate group information on learners from your group who have taken this course in chart formats. ";
	echo "To view group chart information for another course use the pull down menu below.  You can change the viewing options in categories "; 
	echo "by selecting another option in the pull down menu in that category and then hitting the Filter button.</p>";
?>

<?php
  // Checks to see if any of the filters are set
  // If any are it sets them again
  if ( isset ($_POST['time']) ) {
    $_POST['select_time'] = $_POST['time'];
  }
  if ( isset ($_POST['pass']) ) {
    $_POST['select_pass'] = $_POST['pass'];
  }
  if ( isset ($_POST['correct']) ) {
    $_POST['select_correct'] = $_POST['correct'];
  }
?>

<?php if ( $sco_list != NULL && $group_id != NULL ) {
  // This is to select what course the user wants to see charts for ?>
    <form action="../">
      <label>Courses:</label>
      <select onchange="window.open(this.options[this.selectedIndex].value,'_top')">
        <option value="">Choose a course...</option>
        <?php
        // Loops through all of the courses that people in the group have purchased
          foreach ($sco_list as $individual_sco) {
            // Gets and displays the course titles
            $url = $base_root . "/lms/view_group_statistic_chart/" . $group_id . "/" . $individual_sco->scoid;
            echo "<option value=\"" . $url . "\">";
            echo simple_LMS_Get_scocontent_product_title( $individual_sco->nid );
            echo "</option>";
          }
        ?>
      </select>
    </form>
    <br/>
<?php } ?>

<?php 
/* Chart 4 - Lesson Status
-------------------------------------------------------------- */
  if ( $sco_main_report != NULL  && $sco_content != NULL) {
?>
<fieldset id="lesson-status" class="collapsible">
  <legend class = "collapse-processed">
    Lesson Status
  </legend>
  <div class="center"><br/>
  <?php
    // Sets Chart 4 properties
    // 3D Pie Chart
    $chart_4 = array(
      '#chart_id' => 'lesson_status_chart',
      '#type' => CHART_TYPE_PIE_3D,
      '#size' => chart_size(645, 225),
    );
    
    // Number of people who passed
    $num_passed = 0;
    // Number of people who failed
    $num_failed = 0;
    // Number of people who haven't finished the course
    $num_incomplete = 0;
    // Number of people who haven't attempted the course
    $num_not_attempted = 0;
    // Average
    $avg = 0;
    // Total amount of users
    $total_users = count($sco_main_report);
    
    // Loops through looking at each report for for each user in the group
    foreach ( $sco_main_report as $single_report ) {  
      // The status of the user
      $status = $single_report->lesson_status;
      // If the user passed
      if ($status == "passed") {
        $num_passed++;
      } 
      elseif ($status == "failed") { // If the user failed
        $num_failed++;
      } 
      elseif ($status == "incomplete") { // If the user hasn't finished
        $num_incomplete++;
      } 
      elseif ($status == "not attempted") { // If the user hasn't attempted
        $num_not_attempted++;
      }
    }

  // Creates a table of all of the information
  print <<<END
    <div id="status-table">
       <table>
          <tr>
             <td></td>
             <td>Total</td>
             <td>Passed</td>
             <td>Failed</td>
             <td>Incomplete</td>
             <td>Not Attempted</td>
          </tr>
          <tr>
             <td>Number of people</td>
             <td>
END;
    print $total_users;
    echo"</td>";
    echo"<td>";
    print $num_passed;
    echo"</td>";
    echo"<td>";
    print $num_failed;
    echo"</td>";
    echo"<td>";
    print $num_incomplete;
    echo"</td>";
    echo"<td>";
    print $num_not_attempted;
    echo"</td>";
    echo"</tr>";
    echo"</table>";
    echo'</div>';
  
    // If the variable is not zero it is added to the data of the chart
    if ($num_passed != 0) {
      $chart_4['#data']['Passed']  = $num_passed;  
    }
    
    if ($num_failed != 0) {
      $chart_4['#data']['Failed']  = $num_failed;  
    }
    
    if ($num_incomplete != 0) {
      $chart_4['#data']['Incomplete']  = $num_incomplete;  
    }
    
    if ($num_not_attempted != 0) {    
      $chart_4['#data']['Not Attempted'] = $num_not_attempted;
    }    
    
    // Checks to make sure there are users or else there will be division by zero
    if ($total_users != 0) {
      // Finds the average
      // If there is an average then a label and color is added to the pie slice
      $avg = ($num_passed/$total_users) * 100;
      if ($avg != 0) {
        $chart_4['#labels']['Passed'] = t(round($avg) . '% - Passed');
        $chart_4['#data_colors']['Passed'] = $chart_colors[3];
      }
      $avg = ($num_failed/$total_users) * 100;
      if ($avg != 0) {
        $chart_4['#labels']['Failed'] = t(round($avg) . '% - Failed');
        $chart_4['#data_colors']['Failed'] = $chart_colors[0];
      }
      $avg = ($num_incomplete/$total_users) * 100;
      if ($avg != 0) {
        $chart_4['#labels']['Incomplete'] = t(round($avg) . '% - Incomplete');
        $chart_4['#data_colors']['Incomplete'] = $chart_colors[10];
      }
      $avg = ($num_not_attempted/$total_users) * 100;
      if ($avg != 0) {
        $chart_4['#labels']['Not Attempted'] = t(round($avg) . '% - Not Attempted');
        $chart_4['#data_colors']['Not Attempted'] = $chart_colors[11];
      }
    }
    // Renders the chart
    echo chart_render($chart_4);
  ?>
  </div>
</fieldset>
<br/>
<?php 
  }//end if
  /* //////////////////////////END Chart 4 - Lesson Status/////////////////////////// */
?>



<?php 
/* Chart 1 - Distribution of Time
-------------------------------------------------------------- */
  if ( $sco_main_report != NULL  && $sco_content != NULL ) {
    if ($sco_content->scotype != course) {
?>
<fieldset id="time-distribute" class="collapsible">
  <legend class = "collapse-processed">
    Distribution of Time Spent on Course
  </legend>
  <!--
  // Creates a select box and button to filter the data and change the graph
  // Allows the user to choose the time interval for the graph
  -->
  <form method="post">
    <p>Time Increment: 
      <select name="select_time">
        <option value="hour" <?php if (isset($_POST['select_time']) && $_POST['select_time'] == "hour") { echo "SELECTED"; }?>>1 Hour</option>
        <option value="half-hour"<?php if (isset($_POST['select_time']) && $_POST['select_time'] == "half-hour") { echo "SELECTED"; }?>>30 Minutes</option>
        <option value="quarter-hour"<?php if (isset($_POST['select_time']) && $_POST['select_time'] == "quarter-hour") { echo "SELECTED"; }?>>15 Minutes</option>
      </select>
      <!-- 
      // Checks to see if any other filters are set
      -->
      <?php if (isset($_POST['select_pass'])) { ?> <input type="hidden"  name='pass' value='<?php echo $_POST['select_pass']; ?>'/> <?php } ?>
      <?php if (isset($_POST['select_correct'])) { ?> <input type="hidden"  name='correct' value='<?php echo $_POST['select_correct']; ?>'/> <?php } ?>
      <input type="submit"  value="filter"/>
    </p>
  </form>
  <div class="center"><br/>
  <?php

    // Pulls out the information from the filter
    if (isset($_POST['select_time'])) {
      $filter_time = $_POST['select_time'];
    } 
    else {
      // Default value
      $filter_time = 'hour';
    }
    // Time increment
    $inc = 0;

    // Sets Chart 1 properties
    // 3D Pie Chart
    $chart_1 = array(
      '#chart_id' => 'time_slice_chart',
      '#title' => chart_title(t('Hours : Minutes'), '000000', 14),
      '#type' => CHART_TYPE_PIE_3D,
      '#size' => chart_size(645, 225),
    );

    // Checks to see what the filter is set to
    if ($filter_time == "hour") {
      // Increment = 1 hour
      $inc = 1;
      // End time = 15 hours
      $end_time = 15;
    }
    elseif ($filter_time == "half-hour") {
      // Increment = 30 minutes
      $inc = 30;
      // End time = 900 minutes = 15 hours
      $end_time = 900;
    } 
    elseif ($filter_time == "quarter-hour") {
      // Increment = 30 minutes
      $inc = 15;
      // End time = 900 minutes = 15 hours
      $end_time = 900;
    }

    // Loops through looking at each report for for each user in the group
    foreach ( $sco_main_report as $single_report ) {
      // The status of the user
      $check = $single_report->lesson_status;
      // Only times of the people who passed or failed the course will be added to the graph
      if ($check != "not attempted" && $check != "incomplete") {
        // The amount of time the user spent on course
        $t = (float)( simple_LMS_convert_second2hour_format( simple_LMS_calculate_seconds($single_report->total_time) ) );
        
        // If the increment is in minutes the time needs to be converted
        if ($inc != 1) {
          $t = $t*60;
        }
        // The next time increment
        $next = $inc;
        // Start at 0
        // Go until $end_time
        // Increment by $inc
        for ($i = 0; $i <= $end_time; $i += $inc) {
          // Check to if the time falls in the time range
          if ($t >= $i && $t < $next) {
            $time_data[$i]++;
            break;
          }
          elseif ($t > $end_time) { // If the time is greater then the ending time
            $time_data[$end_time]++;
            break;
          }
          // Increment the next time increment
          $next += $inc;
        }
      }
    }

    // Reset the next time increment
    $next = $inc;
    // Text changes if there is a single user or many users
    $user_txt = ' users';
    // label for the pie slice
    $label="";
    // Loop through all of the time increments
    for ( $i = 0; $i <= $end_time; $i += $inc ) {
      // If there is a user in the range
      if ( $time_data[$i] != NULL) {
        // If there is only one user 
        if ($time_data[$i] == 1) {
          $user_txt = ' user';
        }

        // Set the data
        $chart_1['#data'][$i]  = $time_data[$i];

        // If the increment is in hours
        if ($inc == 1) {
          $label = '0'."$i".':'.'00 ~ '.'0'."$next".':'.'00';
        } 
        else {
          // Next Hour increment
          $tmp_next = floor($next/60);
          // Current Hour increment
          $tmp_i = floor($i/60);
          // Next increment remainder in minutes
          $remainder_next = $next-($tmp_next*60);
          // Current increment remainder in minutes
          $remainder_i = $i-($tmp_i*60);
          
          // Add zero to the front if the time is less than 10
          if ( $tmp_i < 10 ) {  
            $label = "0$tmp_i:";  
          }
          else {  
            $label = "$tmp_i" . ':';   
          }

          // Add zero to the front if the remainder is zero
          if ( $remainder_i == 0 ) {
            $label .= "0$remainder_i ~ ";
          } 
          else {
            $label .="$remainder_i".' ~ ';
          }

          // Add zero to the front if the time is less than 10
          if ( $tmp_next < 10 ) {
            $label .= '0'."$tmp_next".':';
          } 
          else {
            $label .="$tmp_next".':';
          }

          // Add zero to the front if the remainder is zero
          if ( $remainder_next == 0) {
            $label .= '0'."$remainder_next";
          } 
          else {
            $label .= "$remainder_next";
          }
        }
        // Add the label to $chart_1
        $chart_1['#labels'][] = t("$label - $time_data[$i]$user_txt");
      }
      // Increment $next
      $next+=$inc;
    }
    // Count the amount of data points in the chart
    $num = count($chart_1['#data']);
    // Add a color for each slice of the pie
    for ($j=0;$j<$num;$j++) {
      // Make sure $j is not larger than the array
      if ($j < 18) {
        $chart_1['#data_colors'][] = $chart_colors[$j];
      }
    }
    // Renders the chart
    echo chart_render($chart_1);
  ?>
  </div>
</fieldset>
<br/>
<?php 
    } // End if
  } // End if
  /* //////////////////////////END Chart 1 - Distribution of Time/////////////////////////// */
?>

<?php 
/* Chart 2 - Score Distribution
-------------------------------------------------------------- */
  if ( $sco_content != NULL && $sco_main_report != NULL ) {
    if ($sco_content->scotype != course) {
?>
<fieldset id="score-distribute" class="collapsible">
  <legend class = "collapse-processed">
    Score Distribution
  </legend>
  <!-- Creates a select box and button to filter the data and change the graph?-->
  <form method="post">
    <p>Pass/Fail
      <select name="select_pass">
        <option value="T" <?php if (isset($_POST['select_pass']) && $_POST['select_pass'] == "T") { echo "SELECTED"; }?>>Total</option>
        <option value="P"<?php if (isset($_POST['select_pass']) && $_POST['select_pass'] == "P") { echo "SELECTED"; }?>>Passed</option>
        <option value="F"<?php if (isset($_POST['select_pass']) && $_POST['select_pass'] == "F") { echo "SELECTED"; }?>>Failed</option>
      </select>
      <!--
      // Checks to see if any other filters are set
      // If any are set the values get passed on
      -->
      <?php if (isset($_POST['select_time'])) { ?> <input type="hidden"  name='time' value='<?php echo $_POST['select_time']; ?>'/> <?php } ?>
      <?php if (isset($_POST['select_correct'])) { ?> <input type="hidden"  name='correct' value='<?php echo $_POST['select_correct']; ?>'/> <?php } ?>
      <input type="submit"  value="filter"/>
    </p>
  </form>
    <div class="center"><br/>
  <?php
  
    // Pulls out the information from the filter
    if (isset($_POST['select_pass'])) {
      $filter_pass = $_POST['select_pass'];
    }
    else {
      // Default value
      $filter_pass = 'T';
    }
    
    // The score a user needs to pass
    $master_score = $sco_content->masteryscore;
    
    // Starting value
    $start_val = 0;
    // Ending value
    $end_val = 0;
    
    // Checks to see what the filter is set to
    if ($filter_pass == "T") {
      // Starting value = 0
      $start_val = 0;
      // Ending value = 100
      $end_val = 100;
    }
    elseif ($filter_pass == "P") {
      // Starting value = the passing score
      $start_val = $master_score;
      // Ending value = 100
      $end_val = 100;
    }
    elseif ($filter_pass == "F") {
      // Starting value = 0
      $start_val = 0;
      // Ending value = the passing score
      $end_val = $master_score;
    }
    
    // Sets Chart 2 properties
    // 3D Pie Chart
    // The title shows the passing score
    $chart_2 = array(
      '#chart_id' => 'score_chart',
      '#title' => chart_title(t('Passing Score: '."$master_score".'%'), '339933', 15),
      '#type' => CHART_TYPE_PIE_3D,
      '#size' => chart_size(645, 225),
    );
    
    // Loops through looking at each report for for each user in the group
    foreach ( $sco_main_report as $single_report ) {  
      // The status of the user
      $check = $single_report->lesson_status;
      // Only times of the people who passed or failed the course will be added to the graph
      if ($check != "not attempted" && $check != "incomplete") {
        // The user's score
        $grade = $single_report->score;
        // A temperary variable holding the bottom of the range
        $temp = $start_val;
        // Loop through all of the score increments
        for ($i = ($start_val+10);$i<=$end_val;$i+=10) {
          // If there is a user in the range
          if ($temp <= $grade && $grade < $i) {
            $score_data[$i]++;
            break;
          }
          elseif ($grade == 100 && $end_val == 100) {
            $score_data[100]++;
            break;
          }
          // Increment the temperary starting increment
          $temp = $i;
        }
      }
    }
    
    // A temperary variable holding the bottom of the range
    $temp = $start_val;
    // Text changes if there is a single user or many users
    $user_txt = ' users';
    for ($i = ($start_val+10);$i<=$end_val;$i+=10) {
      if ( $score_data[$i] != NULL) {
        // If there is only one user 
        if ($score_data[$i] == 1) {
          $user_txt = ' user';
        }
        // Sets the data and the label
        $chart_2['#data'][$i]  = $score_data[$i];
        $chart_2['#labels'][] = t("Scored $temp~$i% : $score_data[$i]$user_txt");
      }
      // Increment the temperary starting increment
      $temp = $i;
    }
    
    // Count the amount of data points in the chart
    $num = count($chart_2['#data']);
    for ($j=0;$j<$num;$j++) {
      // Make sure $j is not larger than the array
      if ($j < 18) {
        // Starts with the 9th color and goes backward in the array
        if ($j < 9) {
          $chart_2['#data_colors'][] = $chart_colors[8-$j];
        }
        // Loops around to the last element in the array and goes backward
        else {
          $chart_2['#data_colors'][] = $chart_colors[26-$j];
        }
      }
    }
    // Renders the chart
    echo chart_render($chart_2);
  ?>
  </div>
</fieldset>
<br/>
<?php 
    }// End if
  }// End if
  /* //////////////////////////END Chart 2 - Score Distribution/////////////////////////// */
?>
<?php 
/* Chart 3 - Percent Correct
-------------------------------------------------------------- */
  if ($sco_questions_list != NULL &&  $sco_content != NULL) {
    if ($sco_content->scotype != course) {
?>

<fieldset id="answer-percent" class="collapsible">
  <legend class = "collapse-processed">
    Percentage Of Correct/Wrong Answers Per Question
  </legend>
  <!--// Creates a select box and button to filter the data and change the graph-->
  <form method="post">
    <p> Answers:
      <select name="select_correct">
        <option value="all" <?php if (isset($_POST['select_correct']) && $_POST['select_correct'] == "all") { echo "SELECTED"; } ?>>Correct And Wrong</option>
        <option value="correct"<?php if (isset($_POST['select_correct']) && $_POST['select_correct'] == "correct") { echo "SELECTED"; } ?>>Correct</option>
        <option value="wrong"<?php if (isset($_POST['select_correct']) && $_POST['select_correct'] == "wrong") { echo "SELECTED"; } ?>>Wrong</option>
      </select>
      <!--
      // Checks to see if any other filters are set
      // If any are set the values get passed on
      ?-->
      <?php if (isset($_POST['select_pass'])) { ?> <input type="hidden"  name='pass' value='<?php echo $_POST['select_pass']; ?>'/> <?php } ?>
      <?php if (isset($_POST['select_time'])) { ?> <input type="hidden"  name='time' value='<?php echo $_POST['select_time']; ?>'/> <?php } ?>
      <input type="submit"  value="filter"/>
    </p>
  </form>
  <div class="center"><br/>
  <?php
    // Pulls out the information from the filter
    if (isset($_POST['select_correct'])) {
      $filter_correct = $_POST['select_correct'];
    }
    else {
      // Default value
      $filter_correct = 'all';
    }
    
    // Total number of users
    $total= 0;
    // A 2D array that holds the number of correct and wrong answers 
    // $question_answer[$question_number]['correct']
    // $question_answer[$question_number]['wrong']
    $question_answer= array(array());
    
    // Loops through looking at each report for for each user in the group
    foreach ($sco_questions_list as $uid) {
      $question_number = 1;
      
      if ($uid != NULL) {
        // Loop through each question for the current user
        foreach ($uid as $question) {
          // Check to see if the the current user
          if ($question->result == 'correct') {
            
            $question_answer[$question_number]['correct']++;
          }
          else {
            $question_answer[$question_number]['wrong']++;
          }
          $question_number++;
        }
        $total++;
      }
    }

    // Average of Correct answers
    $correct_avg = 0;
    // Average of Wrong answers
    $wrong_avg = 0;
    // Number of questions
    $num_questions = count($question_answer)-1;
    // How much to space the grid lines
    $grid_line_spacing = 100/($num_questions-1);
    //$grid_line_spacing = 11.111;

    // Sets Chart 3 properties
    // 2 Line Graph
    $chart_3 = array(
      '#chart_id' => 'percent_correct_chart',
      '#type' => CHART_TYPE_LINE,
      '#size' => chart_size(645, 345),
      '#grid_lines' => chart_grid_lines($grid_line_spacing, 10, 1, 0),       
    );

    // Adds the data to the chart array
    // If any of the averages equals zero it is set to .1
    // ,because if it is zero it won't draw on the chart
    for ($i = 1; $i <= $num_questions; $i++) {
      if ($filter_correct == "all" || $filter_correct == "correct") {
        $correct_avg = ($question_answer[$i]['correct']/$total)*100;
        if ($correct_avg == 0) {
          $correct_avg += .1;
        }
        $chart_3['#data']['correct'][$i]=$correct_avg;  
      }

      if ($filter_correct == "all" || $filter_correct == "wrong") {
        $wrong_avg = ($question_answer[$i]['wrong']/$total)*100;
        if ($wrong_avg == 0) {
          $wrong_avg += .1;
        }
        $chart_3['#data']['wrong'][]=$wrong_avg;
      }
    }

    // Sets the colors and labels of the chart
    if ($filter_correct == "all" || $filter_correct == "correct") {
      //$chart_3['#data']['correct'][] = array(80 , 20 , 30 , 1, 100 , 50 , 40 , 90 , 100 , 10);
      $chart_3['#legends'][] = t('Correct');
      $chart_3['#data_colors'][] = $chart_colors[3];
    }
    if ($filter_correct == "all" || $filter_correct == "wrong") {
      //$chart_3['#data']['wrong'][] = array(20 , 80 , 70 , 100.1 , 50 , 60 , 10 , 1 , 90);
      $chart_3['#legends'][] = t('Wrong');
      $chart_3['#data_colors'][] = $chart_colors[0];
    }

    // Sets the Y-axis
    $chart_3['#mixed_axis_labels'][CHART_AXIS_Y_LEFT][0][] = chart_mixed_axis_range_label(0, 100);
    $chart_3['#mixed_axis_labels'][CHART_AXIS_Y_LEFT][1][] = chart_mixed_axis_label(t('% of Users'), 50);
    // Sets the X-axis
    $chart_3['#mixed_axis_labels'][CHART_AXIS_X_BOTTOM][1][] = chart_mixed_axis_range_label(1, "$num_questions");
    //$chart_3['#mixed_axis_labels'][CHART_AXIS_X_BOTTOM][1][] = chart_mixed_axis_range_label(1, 10);
    $chart_3['#mixed_axis_labels'][CHART_AXIS_X_BOTTOM][2][] = chart_mixed_axis_label(t('Question Number'), 50);
    
    // Renders chart 3
    echo chart_render($chart_3);
  ?>
  </div>
</fieldset>

<?php 
    }// End if
  }// End if
  /* //////////////////////////END Chart 3 - Percent Correct/////////////////////////// */